#pragma once

#include <time.h>
#include "OSUInventor.h"
#include "raytracer.h"

namespace WinRay
{
	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Runtime::InteropServices;

	/// <summary> 
	/// Summary for Form1
	///
	/// WARNING: If you change the name of this class, you will need to change the 
	///          'Resource File Name' property for the managed resource compiler tool 
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public __gc class Form1 : public System::Windows::Forms::Form
	{	
	public:
		Form1(void)
		{
			InitializeComponent();
			drawing = new Bitmap(2048, 2048);
			frame = -1;
			fstopCombo->SelectedIndex = 0;
		}
  
	protected:
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
	private: System::Windows::Forms::OpenFileDialog *  openFileDialog1;
	private: System::Windows::Forms::SaveFileDialog *  saveFileDialog1;
	private: System::Windows::Forms::Button *  button1;
	private: Bitmap *drawing;
	private: Scene *_scene;
	private: Camera *_camera;
	private: int sl, sl_last;
	private: int frame;
	private: float radius, y;
	private: bool quick;
	private: int path_count;
	private: System::Windows::Forms::Timer *  timer1;

	private: System::Windows::Forms::NumericUpDown *  resUpDown;
	private: System::Windows::Forms::CheckBox *  textureCheck;
	private: System::Windows::Forms::Panel *  drawPanel;
	private: System::Windows::Forms::CheckBox *  antialiasCheck;
	private: System::Windows::Forms::TextBox *  ray_text;
	private: System::Windows::Forms::TextBox *  aa_text;
	private: System::Windows::Forms::Button *  button2;
	private: System::Windows::Forms::RadioButton *  uniformRadio;
	private: System::Windows::Forms::GroupBox *  groupBox1;
	private: System::Windows::Forms::RadioButton *  jitteredRadio;
	private: System::Windows::Forms::RadioButton *  randomRadio;
	private: System::Windows::Forms::GroupBox *  groupBox2;
	private: System::Windows::Forms::RadioButton *  boxRadio;
	private: System::Windows::Forms::RadioButton *  tentRadio;
	private: System::Windows::Forms::RadioButton *  mnRadio;
	private: System::Windows::Forms::GroupBox *  groupBox3;
	private: System::Windows::Forms::CheckBox *  jitterShadowCheck;
	private: System::Windows::Forms::RadioButton *  boxShadowRadio;
	private: System::Windows::Forms::RadioButton *  tentShadowRadio;
	private: System::Windows::Forms::GroupBox *  groupBox4;
	private: System::Windows::Forms::NumericUpDown *  focalUpDown;
	private: System::Windows::Forms::Label *  label1;
	private: System::Windows::Forms::Label *  label2;
	private: System::Windows::Forms::ComboBox *  fstopCombo;
	private: System::Windows::Forms::Timer *  timer2;
	private: System::Windows::Forms::NumericUpDown *  samplesUpDown;
	private: System::Windows::Forms::GroupBox *  groupBox5;





	private: System::ComponentModel::IContainer *  components;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>


		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = new System::ComponentModel::Container();
			this->openFileDialog1 = new System::Windows::Forms::OpenFileDialog();
			this->saveFileDialog1 = new System::Windows::Forms::SaveFileDialog();
			this->button1 = new System::Windows::Forms::Button();
			this->timer1 = new System::Windows::Forms::Timer(this->components);
			this->resUpDown = new System::Windows::Forms::NumericUpDown();
			this->textureCheck = new System::Windows::Forms::CheckBox();
			this->drawPanel = new System::Windows::Forms::Panel();
			this->antialiasCheck = new System::Windows::Forms::CheckBox();
			this->ray_text = new System::Windows::Forms::TextBox();
			this->aa_text = new System::Windows::Forms::TextBox();
			this->button2 = new System::Windows::Forms::Button();
			this->uniformRadio = new System::Windows::Forms::RadioButton();
			this->groupBox1 = new System::Windows::Forms::GroupBox();
			this->jitteredRadio = new System::Windows::Forms::RadioButton();
			this->randomRadio = new System::Windows::Forms::RadioButton();
			this->groupBox2 = new System::Windows::Forms::GroupBox();
			this->boxRadio = new System::Windows::Forms::RadioButton();
			this->tentRadio = new System::Windows::Forms::RadioButton();
			this->mnRadio = new System::Windows::Forms::RadioButton();
			this->groupBox3 = new System::Windows::Forms::GroupBox();
			this->boxShadowRadio = new System::Windows::Forms::RadioButton();
			this->jitterShadowCheck = new System::Windows::Forms::CheckBox();
			this->tentShadowRadio = new System::Windows::Forms::RadioButton();
			this->groupBox4 = new System::Windows::Forms::GroupBox();
			this->fstopCombo = new System::Windows::Forms::ComboBox();
			this->label1 = new System::Windows::Forms::Label();
			this->focalUpDown = new System::Windows::Forms::NumericUpDown();
			this->label2 = new System::Windows::Forms::Label();
			this->timer2 = new System::Windows::Forms::Timer(this->components);
			this->samplesUpDown = new System::Windows::Forms::NumericUpDown();
			this->groupBox5 = new System::Windows::Forms::GroupBox();
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->resUpDown))->BeginInit();
			this->groupBox1->SuspendLayout();
			this->groupBox2->SuspendLayout();
			this->groupBox3->SuspendLayout();
			this->groupBox4->SuspendLayout();
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->focalUpDown))->BeginInit();
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->samplesUpDown))->BeginInit();
			this->groupBox5->SuspendLayout();
			this->SuspendLayout();
			// 
			// openFileDialog1
			// 
			this->openFileDialog1->Filter = S"IV files|*.iv|All files|*.*";
			// 
			// button1
			// 
			this->button1->Location = System::Drawing::Point(8, 8);
			this->button1->Name = S"button1";
			this->button1->TabIndex = 0;
			this->button1->Text = S"Ray Trace";
			this->button1->Click += new System::EventHandler(this, Raytrace);
			// 
			// timer1
			// 
			this->timer1->Interval = 1;
			this->timer1->Tick += new System::EventHandler(this, timer1_Tick);
			// 
			// resUpDown
			// 
			this->resUpDown->Location = System::Drawing::Point(168, 8);
			System::Int32 __mcTemp__1[] = new System::Int32[4];
			__mcTemp__1[0] = 2048;
			__mcTemp__1[1] = 0;
			__mcTemp__1[2] = 0;
			__mcTemp__1[3] = 0;
			this->resUpDown->Maximum = System::Decimal(__mcTemp__1);
			System::Int32 __mcTemp__2[] = new System::Int32[4];
			__mcTemp__2[0] = 32;
			__mcTemp__2[1] = 0;
			__mcTemp__2[2] = 0;
			__mcTemp__2[3] = 0;
			this->resUpDown->Minimum = System::Decimal(__mcTemp__2);
			this->resUpDown->Name = S"resUpDown";
			this->resUpDown->Size = System::Drawing::Size(56, 20);
			this->resUpDown->TabIndex = 2;
			System::Int32 __mcTemp__3[] = new System::Int32[4];
			__mcTemp__3[0] = 512;
			__mcTemp__3[1] = 0;
			__mcTemp__3[2] = 0;
			__mcTemp__3[3] = 0;
			this->resUpDown->Value = System::Decimal(__mcTemp__3);
			// 
			// textureCheck
			// 
			this->textureCheck->Location = System::Drawing::Point(232, 8);
			this->textureCheck->Name = S"textureCheck";
			this->textureCheck->Size = System::Drawing::Size(72, 24);
			this->textureCheck->TabIndex = 3;
			this->textureCheck->Text = S"Textures";
			// 
			// drawPanel
			// 
			this->drawPanel->Anchor = (System::Windows::Forms::AnchorStyles)((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left);
			this->drawPanel->Location = System::Drawing::Point(8, 120);
			this->drawPanel->Name = S"drawPanel";
			this->drawPanel->Size = System::Drawing::Size(72, 64);
			this->drawPanel->TabIndex = 4;
			this->drawPanel->Paint += new System::Windows::Forms::PaintEventHandler(this, drawPanel_Paint);
			// 
			// antialiasCheck
			// 
			this->antialiasCheck->Checked = true;
			this->antialiasCheck->CheckState = System::Windows::Forms::CheckState::Checked;
			this->antialiasCheck->Location = System::Drawing::Point(304, 8);
			this->antialiasCheck->Name = S"antialiasCheck";
			this->antialiasCheck->Size = System::Drawing::Size(72, 24);
			this->antialiasCheck->TabIndex = 3;
			this->antialiasCheck->Text = S"Anti-Alias";
			// 
			// ray_text
			// 
			this->ray_text->Location = System::Drawing::Point(376, 8);
			this->ray_text->Name = S"ray_text";
			this->ray_text->Size = System::Drawing::Size(72, 20);
			this->ray_text->TabIndex = 5;
			this->ray_text->Text = S"0";
			// 
			// aa_text
			// 
			this->aa_text->Location = System::Drawing::Point(456, 8);
			this->aa_text->Name = S"aa_text";
			this->aa_text->Size = System::Drawing::Size(64, 20);
			this->aa_text->TabIndex = 6;
			this->aa_text->Text = S"0";
			// 
			// button2
			// 
			this->button2->Enabled = false;
			this->button2->Location = System::Drawing::Point(88, 8);
			this->button2->Name = S"button2";
			this->button2->TabIndex = 0;
			this->button2->Text = S"Animate";
			this->button2->Click += new System::EventHandler(this, button2_Click);
			// 
			// uniformRadio
			// 
			this->uniformRadio->Location = System::Drawing::Point(8, 16);
			this->uniformRadio->Name = S"uniformRadio";
			this->uniformRadio->Size = System::Drawing::Size(64, 16);
			this->uniformRadio->TabIndex = 7;
			this->uniformRadio->Text = S"Uniform";
			// 
			// groupBox1
			// 
			this->groupBox1->Controls->Add(this->uniformRadio);
			this->groupBox1->Controls->Add(this->jitteredRadio);
			this->groupBox1->Controls->Add(this->randomRadio);
			this->groupBox1->Location = System::Drawing::Point(8, 40);
			this->groupBox1->Name = S"groupBox1";
			this->groupBox1->Size = System::Drawing::Size(88, 72);
			this->groupBox1->TabIndex = 8;
			this->groupBox1->TabStop = false;
			this->groupBox1->Text = S"Sampling";
			// 
			// jitteredRadio
			// 
			this->jitteredRadio->Checked = true;
			this->jitteredRadio->Location = System::Drawing::Point(8, 32);
			this->jitteredRadio->Name = S"jitteredRadio";
			this->jitteredRadio->Size = System::Drawing::Size(64, 16);
			this->jitteredRadio->TabIndex = 7;
			this->jitteredRadio->TabStop = true;
			this->jitteredRadio->Text = S"Jittered";
			// 
			// randomRadio
			// 
			this->randomRadio->Location = System::Drawing::Point(8, 48);
			this->randomRadio->Name = S"randomRadio";
			this->randomRadio->Size = System::Drawing::Size(72, 16);
			this->randomRadio->TabIndex = 7;
			this->randomRadio->Text = S"Random";
			// 
			// groupBox2
			// 
			this->groupBox2->Controls->Add(this->boxRadio);
			this->groupBox2->Controls->Add(this->tentRadio);
			this->groupBox2->Controls->Add(this->mnRadio);
			this->groupBox2->Location = System::Drawing::Point(104, 40);
			this->groupBox2->Name = S"groupBox2";
			this->groupBox2->Size = System::Drawing::Size(64, 72);
			this->groupBox2->TabIndex = 8;
			this->groupBox2->TabStop = false;
			this->groupBox2->Text = S"Filter";
			// 
			// boxRadio
			// 
			this->boxRadio->Location = System::Drawing::Point(8, 16);
			this->boxRadio->Name = S"boxRadio";
			this->boxRadio->Size = System::Drawing::Size(48, 16);
			this->boxRadio->TabIndex = 7;
			this->boxRadio->Text = S"Box";
			// 
			// tentRadio
			// 
			this->tentRadio->Checked = true;
			this->tentRadio->Location = System::Drawing::Point(8, 32);
			this->tentRadio->Name = S"tentRadio";
			this->tentRadio->Size = System::Drawing::Size(48, 16);
			this->tentRadio->TabIndex = 7;
			this->tentRadio->TabStop = true;
			this->tentRadio->Text = S"Tent";
			// 
			// mnRadio
			// 
			this->mnRadio->Location = System::Drawing::Point(8, 48);
			this->mnRadio->Name = S"mnRadio";
			this->mnRadio->Size = System::Drawing::Size(48, 16);
			this->mnRadio->TabIndex = 7;
			this->mnRadio->Text = S"M-N";
			// 
			// groupBox3
			// 
			this->groupBox3->Controls->Add(this->boxShadowRadio);
			this->groupBox3->Controls->Add(this->jitterShadowCheck);
			this->groupBox3->Controls->Add(this->tentShadowRadio);
			this->groupBox3->Location = System::Drawing::Point(176, 40);
			this->groupBox3->Name = S"groupBox3";
			this->groupBox3->Size = System::Drawing::Size(96, 72);
			this->groupBox3->TabIndex = 8;
			this->groupBox3->TabStop = false;
			this->groupBox3->Text = S"Soft Shadows";
			// 
			// boxShadowRadio
			// 
			this->boxShadowRadio->Location = System::Drawing::Point(8, 32);
			this->boxShadowRadio->Name = S"boxShadowRadio";
			this->boxShadowRadio->Size = System::Drawing::Size(72, 16);
			this->boxShadowRadio->TabIndex = 1;
			this->boxShadowRadio->Text = S"Box Filter";
			// 
			// jitterShadowCheck
			// 
			this->jitterShadowCheck->Checked = true;
			this->jitterShadowCheck->CheckState = System::Windows::Forms::CheckState::Checked;
			this->jitterShadowCheck->Location = System::Drawing::Point(8, 16);
			this->jitterShadowCheck->Name = S"jitterShadowCheck";
			this->jitterShadowCheck->Size = System::Drawing::Size(72, 16);
			this->jitterShadowCheck->TabIndex = 0;
			this->jitterShadowCheck->Text = S"Jittering";
			// 
			// tentShadowRadio
			// 
			this->tentShadowRadio->Checked = true;
			this->tentShadowRadio->Location = System::Drawing::Point(8, 48);
			this->tentShadowRadio->Name = S"tentShadowRadio";
			this->tentShadowRadio->Size = System::Drawing::Size(80, 16);
			this->tentShadowRadio->TabIndex = 1;
			this->tentShadowRadio->TabStop = true;
			this->tentShadowRadio->Text = S"Tent Filter";
			// 
			// groupBox4
			// 
			this->groupBox4->Controls->Add(this->fstopCombo);
			this->groupBox4->Controls->Add(this->label1);
			this->groupBox4->Controls->Add(this->focalUpDown);
			this->groupBox4->Controls->Add(this->label2);
			this->groupBox4->Location = System::Drawing::Point(280, 40);
			this->groupBox4->Name = S"groupBox4";
			this->groupBox4->Size = System::Drawing::Size(160, 72);
			this->groupBox4->TabIndex = 9;
			this->groupBox4->TabStop = false;
			this->groupBox4->Text = S"Camera";
			// 
			// fstopCombo
			// 
			this->fstopCombo->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			System::Object* __mcTemp__4[] = new System::Object*[6];
			__mcTemp__4[0] = S"Off";
			__mcTemp__4[1] = S"1";
			__mcTemp__4[2] = S"1.4";
			__mcTemp__4[3] = S"2";
			__mcTemp__4[4] = S"2.8";
			__mcTemp__4[5] = S"4";
			this->fstopCombo->Items->AddRange(__mcTemp__4);
			this->fstopCombo->Location = System::Drawing::Point(72, 40);
			this->fstopCombo->Name = S"fstopCombo";
			this->fstopCombo->Size = System::Drawing::Size(80, 21);
			this->fstopCombo->TabIndex = 2;
			// 
			// label1
			// 
			this->label1->Location = System::Drawing::Point(8, 16);
			this->label1->Name = S"label1";
			this->label1->Size = System::Drawing::Size(64, 16);
			this->label1->TabIndex = 1;
			this->label1->Text = S"Focal Dist:";
			// 
			// focalUpDown
			// 
			this->focalUpDown->DecimalPlaces = 1;
			System::Int32 __mcTemp__5[] = new System::Int32[4];
			__mcTemp__5[0] = 1;
			__mcTemp__5[1] = 0;
			__mcTemp__5[2] = 0;
			__mcTemp__5[3] = 65536;
			this->focalUpDown->Increment = System::Decimal(__mcTemp__5);
			this->focalUpDown->Location = System::Drawing::Point(72, 16);
			System::Int32 __mcTemp__6[] = new System::Int32[4];
			__mcTemp__6[0] = 1;
			__mcTemp__6[1] = 0;
			__mcTemp__6[2] = 0;
			__mcTemp__6[3] = 0;
			this->focalUpDown->Minimum = System::Decimal(__mcTemp__6);
			this->focalUpDown->Name = S"focalUpDown";
			this->focalUpDown->Size = System::Drawing::Size(80, 20);
			this->focalUpDown->TabIndex = 0;
			System::Int32 __mcTemp__7[] = new System::Int32[4];
			__mcTemp__7[0] = 10;
			__mcTemp__7[1] = 0;
			__mcTemp__7[2] = 0;
			__mcTemp__7[3] = 0;
			this->focalUpDown->Value = System::Decimal(__mcTemp__7);
			// 
			// label2
			// 
			this->label2->Location = System::Drawing::Point(8, 40);
			this->label2->Name = S"label2";
			this->label2->Size = System::Drawing::Size(64, 16);
			this->label2->TabIndex = 1;
			this->label2->Text = S"f-Stop:";
			// 
			// timer2
			// 
			this->timer2->Interval = 1;
			this->timer2->Tick += new System::EventHandler(this, timer2_Tick);
			// 
			// samplesUpDown
			// 
			this->samplesUpDown->Location = System::Drawing::Point(8, 16);
			System::Int32 __mcTemp__8[] = new System::Int32[4];
			__mcTemp__8[0] = 300;
			__mcTemp__8[1] = 0;
			__mcTemp__8[2] = 0;
			__mcTemp__8[3] = 0;
			this->samplesUpDown->Maximum = System::Decimal(__mcTemp__8);
			System::Int32 __mcTemp__9[] = new System::Int32[4];
			__mcTemp__9[0] = 4;
			__mcTemp__9[1] = 0;
			__mcTemp__9[2] = 0;
			__mcTemp__9[3] = 0;
			this->samplesUpDown->Minimum = System::Decimal(__mcTemp__9);
			this->samplesUpDown->Name = S"samplesUpDown";
			this->samplesUpDown->Size = System::Drawing::Size(56, 20);
			this->samplesUpDown->TabIndex = 10;
			System::Int32 __mcTemp__10[] = new System::Int32[4];
			__mcTemp__10[0] = 4;
			__mcTemp__10[1] = 0;
			__mcTemp__10[2] = 0;
			__mcTemp__10[3] = 0;
			this->samplesUpDown->Value = System::Decimal(__mcTemp__10);
			// 
			// groupBox5
			// 
			this->groupBox5->Controls->Add(this->samplesUpDown);
			this->groupBox5->Location = System::Drawing::Point(448, 40);
			this->groupBox5->Name = S"groupBox5";
			this->groupBox5->Size = System::Drawing::Size(72, 72);
			this->groupBox5->TabIndex = 11;
			this->groupBox5->TabStop = false;
			this->groupBox5->Text = S"Samples";
			// 
			// Form1
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 13);
			this->BackColor = System::Drawing::SystemColors::Control;
			this->ClientSize = System::Drawing::Size(530, 192);
			this->Controls->Add(this->groupBox5);
			this->Controls->Add(this->groupBox4);
			this->Controls->Add(this->groupBox1);
			this->Controls->Add(this->aa_text);
			this->Controls->Add(this->ray_text);
			this->Controls->Add(this->antialiasCheck);
			this->Controls->Add(this->drawPanel);
			this->Controls->Add(this->textureCheck);
			this->Controls->Add(this->resUpDown);
			this->Controls->Add(this->button1);
			this->Controls->Add(this->button2);
			this->Controls->Add(this->groupBox2);
			this->Controls->Add(this->groupBox3);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
			this->MinimumSize = System::Drawing::Size(536, 224);
			this->Name = S"Form1";
			this->Text = S"WinRay";
			this->Load += new System::EventHandler(this, Form1_Load);
			this->Paint += new System::Windows::Forms::PaintEventHandler(this, Form1_Paint);
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->resUpDown))->EndInit();
			this->groupBox1->ResumeLayout(false);
			this->groupBox2->ResumeLayout(false);
			this->groupBox3->ResumeLayout(false);
			this->groupBox4->ResumeLayout(false);
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->focalUpDown))->EndInit();
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->samplesUpDown))->EndInit();
			this->groupBox5->ResumeLayout(false);
			this->ResumeLayout(false);

		}	

	private: System::Void Form1_Load(System::Object *  sender, System::EventArgs *  e)
			 {
				 this->ResizeRedraw = true;
			 }

	/*protected: void OnPaintBackground(PaintEventArgs* pevent)
			{
				// Do nothing.
			}*/



	private: System::Void Raytrace(System::Object *  sender, System::EventArgs *  e)
			 {
				 if (openFileDialog1->ShowDialog() == DialogResult::OK) {
					 this->Height = 160 + Decimal::ToInt32(resUpDown->Value);
					 this->Width = 24 + Decimal::ToInt32(resUpDown->Value);
					 drawPanel->Width = Decimal::ToInt32(resUpDown->Value);

					 _scene = new Scene();
					 _camera = new Camera();

					 // Set up filtering parameters
					 if(uniformRadio->Checked)
						 _camera->_sampling = 0;
					 else if(jitteredRadio->Checked)
						 _camera->_sampling = 1;
					 else if(randomRadio->Checked)
						 _camera->_sampling = 2;

					 if(boxRadio->Checked)
						 _camera->_reconst = 0;
					 else if(tentRadio->Checked)
						 _camera->_reconst = 1;
					 else if(mnRadio->Checked)
						 _camera->_reconst = 2;

					 if(jitterShadowCheck->Checked)
						 _camera->_shadow_samp = 1;
					 else 
						 _camera->_shadow_samp = 0;

					 if(boxShadowRadio->Checked)
						 _camera->_shadow_filt = 0;
					 else if(tentShadowRadio->Checked)
						 _camera->_shadow_filt = 1;

					 // set up camera focus params
					 _camera->_focal_dist = Decimal::ToSingle(focalUpDown->Value);
					 if(fstopCombo->SelectedIndex == 0)
						 _camera->_aperture = 0.0f;
					 else
						_camera->_aperture = pow(0.5f, fstopCombo->SelectedIndex - 1);

					 char *filename = (char*)(void*)Marshal::StringToHGlobalAnsi(openFileDialog1->FileName);
					 raytrace_load(filename, Decimal::ToInt32(resUpDown->Value), _scene, _camera, textureCheck->Checked);
					 _camera->rayTraceSetup(_scene);
					 _camera->_subsamples = Decimal::ToSingle(samplesUpDown->Value);

					 quick = true;
					 if(frame > 0) {
						 quick = false;
						 SbVec3f eye = _camera->getPosition();
						 y = eye[1];
						 radius = sqrt(eye[0]*eye[0] + eye[2]*eye[2]);
					 }
					 sl = 0;
					 path_count = 100000;
					 timer2->Enabled = false;
					 timer1->Enabled = true;
				 }

				 drawPanel->Invalidate();
			 }
	private: System::Void timer1_Tick(System::Object *  sender, System::EventArgs *  e)
			 {
				 sl_last = sl;
				 clock_t endwait;
				 endwait = clock () + .5 * CLK_TCK ;
				 while (clock() < endwait) {
					 _camera->rayTraceScanline(_scene, drawing, sl++, quick, antialiasCheck->Checked);
					 if(sl >= Decimal::ToInt32(resUpDown->Value)) {
						 drawPanel->Invalidate(Rectangle(0, sl_last, Decimal::ToInt32(resUpDown->Value), sl-sl_last));
						 if(quick) {
							 quick = false;
							 sl = 0;
							 _camera->ray_count = 0;
						 }
						 else {
							timer1->Enabled = false;
							//timer2->Enabled = true;
						 }
						 return;
					 }
				 }
				 ray_text->Text = _camera->ray_count.ToString();
				 aa_text->Text = _camera->aa_count.ToString();
				 drawPanel->Invalidate(Rectangle(0, sl_last, Decimal::ToInt32(resUpDown->Value), sl-sl_last));
			 }

	private: System::Void drawPanel_Paint(System::Object *  sender, System::Windows::Forms::PaintEventArgs *  e)
			{
				e->Graphics->DrawImage(drawing, 0, e->ClipRectangle.get_Y(), e->ClipRectangle, GraphicsUnit::Pixel);
			}

	private: System::Void Form1_Paint(System::Object *  sender, System::Windows::Forms::PaintEventArgs *  e)
			{
				drawPanel->Invalidate();
			}

	private: System::Void button2_Click(System::Object *  sender, System::EventArgs *  e)
			{
				frame = 1;
				Raytrace(sender, e);
			}

private: System::Void timer2_Tick(System::Object *  sender, System::EventArgs *  e)
		 {
			clock_t endwait;
			endwait = clock () + .5 * CLK_TCK ;
			while (clock() < endwait) {
				_camera->pathTrace(_scene, drawing);
				if(path_count <= 0) {
					drawPanel->Invalidate();
					timer2->Enabled = false;
					return;
				}
				path_count--;
			}
			drawPanel->Invalidate();
		 }

};
}


